<template>
	<div>
		<v-data-table
				:disable-filtering="true"
				:disable-sort="true"
				:headers="headers"
				:items="getSortedPoints"
				:locale="locale"
				:mobile-breakpoint='NaN'
				class="elevation-1"
				dense>
			<template slot="header" slot-scope="props">
				<tr>
					<th :key="header.text" v-for="header in props.headers">
						{{ header.text }}
					</th>
				</tr>
			</template>
			<template slot="item" slot-scope="item">
				<tr v-bind:class="{'gray': isMe(item.item.owner.id)}">
					<td>{{ item.item.id }}</td>
					<td>{{ item.item.x }}</td>
					<td>{{ item.item.y }}</td>
					<td>{{ item.item.r }}</td>
					<td>
						<v-icon color="gray" v-if="item.item.hit == null">fa-times-circle</v-icon>
						<v-icon color="green" v-else-if="item.item.hit">fa-plus-circle</v-icon>
						<v-icon color="red" v-else-if="!item.item.hit">fa-minus-circle</v-icon>
					</td>
					<td>{{ item.item.time }}</td>
					<td>{{ item.item.owner.login }}</td>
<!--					<td>-->
<!--						<v-btn :disabled="!isMe(item.item.owner.id)" @click="clickOnEditButton(item.item)">-->
<!--							Изменить-->
<!--						</v-btn>-->
<!--					</td>-->
				</tr>
			</template>
		</v-data-table>

		<v-row justify="center">
			<v-dialog max-width="600px" persistent v-model="dialog">
				<v-card>
					<v-card-title>
						<span class="headline">Изменить точку # {{ index_selected }}</span>
					</v-card-title>
					<v-card-text>
						<v-form ref="form" v-model="valid">
							<v-row>
								<v-col cols="12">
									<v-text-field :counter="15" :rules="getXRules" label="X" required
												  v-model="x_input"/>
								</v-col>
								<v-col cols="12">
									<v-text-field :counter="15" :rules="getYRules" label="Y" required
												  v-model="y_input"/>
								</v-col>
								<v-col cols="12" sm="6">
									<v-text-field :counter="15" :rules="getRRules" label="R" required
												  v-model="r_input"/>
								</v-col>
							</v-row>
						</v-form>
					</v-card-text>
					<v-card-actions>
						<v-spacer/>
						<v-btn @click="dialog = false" color="blue darken-1" text>Close</v-btn>
						<v-btn :disabled="!valid" @click="clickOnSaveButton" color="blue darken-1" text>Save</v-btn>
					</v-card-actions>
				</v-card>
			</v-dialog>
		</v-row>
	</div>
</template>

<script>
    import {mapActions, mapGetters} from "vuex";

    export default {
        name: "TableComponent",
        data() {
            return {
                locale: "ru-RU",
                textButtonEdit: "Изменить",
                headers: [
                    {text: '#', sortable: false, width: "7%"},
                    {text: 'X', sortable: false,},
                    {text: 'Y', sortable: false,},
                    {text: 'R', sortable: false,},
                    {text: 'HIT', sortable: false,},
                    {text: 'Date', sortable: false,},
                    {text: 'Owner', sortable: false,},
                    // {text: 'Edit', sortable: false,},
                ],
                noData: 'Не выбрана',
                dialog: false,
                valid: true,
                x_input: '',
                y_input: '',
                r_input: '',
                index_selected: '',
            }
        },
        computed: {
            ...mapGetters(['getSortedPoints', 'isMe', "getXRules", "getYRules", "getRRules"]),
        },
        methods: {
            ...mapActions(['loadPointsAction', "updatePointAction"]),
            clickOnEditButton(item) {
                this.index_selected = item.id;
                this.x_input = item.x;
                this.y_input = item.y;
                this.r_input = item.r;
                this.dialog = true;
            },
            clickOnSaveButton() {
                const data = {
                    id: this.index_selected,
                    x: this.x_input,
                    y: this.y_input,
                    r: this.r_input,
                };
                this.updatePointAction(data);
                this.dialog = false;
            },
        },
        mounted() {
            this.loadPointsAction();
        }
    }
</script>

<style scoped>

</style>